/*
   CIPEX - encrypted and compressed IP over UDP tunneling

   mlzowrap.c - MiniLZO wrapper for the compression/expansion part of 
   the CIPEX device

   Copyright 2003 J.J.G. Steegers <hsx@dds.nl>
    
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version
   2 of the License, or (at your option) any later version.
*/

#include "../mlzo/minilzo.h"

/* wrapper for mini-lzo compresser */
int mlzo_compress(	unsigned char *inbuf,unsigned char *outbuf, 
			unsigned char *lzo_w,int len, int *outlen) {

    if (lzo_init() != LZO_E_OK)  return(0);

    if (lzo1x_1_compress(inbuf,len,outbuf,outlen,lzo_w) !=LZO_E_OK) 
	return(0);

    return (len > *outlen ? 1 : 0);
} 

/* wrapper for mini-lzo expander */
int mlzo_expand(unsigned char *inbuf, unsigned char *outbuf, 
		int len, int *outlen) {

    if (lzo_init() != LZO_E_OK)  return(0);

    if (lzo1x_decompress(inbuf,len,outbuf,outlen,((void *)0))!=LZO_E_OK)
	return(0);

    return(1);
} 

